> For the complete documentation index, see [llms.txt](https://docs.hex-rays.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.hex-rays.com/archive/enum-tutorial.md).

# Enumerated types tutorial

This screen capture (IDA 3.66) shows how IDA handles high level structures. This tutorial shows you how to obtain this result.

![](https://1926493584-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FD7fgl4EL0WWJ18ZQcIxE%2Fuploads%2Fgit-blob-8016113bef903431e2ef735a278f209eb6b9d0c1%2Fidaenum.gif?alt=media)

You can use IDA to interactively define and manipulate enumerated types in the disassembly. Consider this simple sample C program:

```
enum color_t {
    BLACK,          /* dark colors */
    BLUE,
    GREEN,
    CYAN,
    RED,
    MAGENTA,
    BROWN,
    LIGHTGRAY,
    DARKGRAY,           /* light colors */
    LIGHTBLUE,
    LIGHTGREEN,
    LIGHTCYAN,
    LIGHTRED,
    LIGHTMAGENTA,
    YELLOW,
    WHITE
};

enum day_t { MONDAY, TUESDAY, WEDNESDAY, THUSDAY, FRIDAY, SATURDAY, SUNDAY };

enum bool_t { FALSE, TRUE };

int is_suitable_color(day_t day,color_t color) {
  if ( (day == SUNDAY || day == SATURDAY) && color == RED ) return TRUE;
  if ( color == BLACK || color == BLUE ) return TRUE;
  return FALSE;
}
```

In order to use meaningful names instead of numbers, we open the enums window and press insert to define a new enumerated type.

![](https://1926493584-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FD7fgl4EL0WWJ18ZQcIxE%2Fuploads%2Fgit-blob-a533b806036bbf08960a3f643af8704aacc44bcf%2Fidaenumdef.gif?alt=media)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.hex-rays.com/archive/enum-tutorial.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
